# Summary

[Introduction](index.md)

* [Quickstart](quickstart/index.md)
    * [Installation](quickstart/installation.md)
    * [Write your first contract](quickstart/first_contract.md)
    * [Deploying a contract to a testnet](quickstart/deploy_contract.md)
* [Development](development/index.md)
    * [Build & Test](development/build.md)
    * [Release](development/release.md)
* [Specification (WIP)](spec/index.md)
    * [Notation](spec/notation.md)
    * [Lexical Structure](spec/lexical_structure.md)
        * [Keywords](spec/keywords.md)
        * [Identifiers](spec/identifiers.md)
        * [Tokens](spec/tokens.md)
    * [Comments](spec/comments.md)
    * [Items](spec/items.md)
        * [Visibility and Privacy](spec/visibility_and_privacy.md)
        * [Functions](spec/functions.md)
        * [Structs](spec/structs.md)
        * [Events](spec/events.md)
        * [Enumeration](spec/enumeration.md)
        * [Type Aliases](spec/type_aliases.md)
        * [Contracts](spec/contracts.md)
    * [Statements](spec/statements.md)
        * [`pragma` Statement](spec/statement_pragma.md)
        * [`const` Statement](spec/statement_const.md)
        * [`let` Statement](spec/statement_let.md)
        * [Assignment Statement](spec/statement_assign.md)
        * [Augmenting Assignment Statement](spec/statement_augassign.md)
        * [`revert` Statement](spec/statement_revert.md)
        * [`return` Statement](spec/statement_return.md)
        * [`emit` Statement](spec/statement_emit.md)
        * [`if` Statement](spec/statement_if.md)
        * [`for` Statement](spec/statement_for.md)
        * [`while` Statement](spec/statement_while.md)
        * [`break` Statement](spec/statement_break.md)
        * [`continue` Statement](spec/statement_continue.md)
        * [`assert` Statement](spec/statement_assert.md)
        * [`pass` Statement](spec/statement_pass.md)
    * [Expressions](spec/expressions.md)
        * [Call expressions](spec/expr_call.md)
        * [Tuple expressions](spec/expr_tuple.md)
        * [List expressions](spec/expr_list.md)
        * [Index expressions](spec/expr_index.md)
        * [Attribute expressions](spec/expr_attribute.md)
        * [Name expressions](spec/expr_name.md)
        * [Literal expressions](spec/expr_literal.md)
        * [Arithmetic Operators](spec/expr_arithmetic_operators.md)
        * [Comparision Operators](spec/expr_comparision_operators.md)
        * [Boolean Operators](spec/expr_boolean_operators.md)
        * [Unary Operators](spec/expr_unary_operators.md)
    * [Type System](spec/type_system.md)
        * [Types](spec/types.md)
            * [Boolean Type](spec/boolean_type.md)
            * [Contract Type](spec/contract_types.md)
            * [Numeric Types](spec/numeric_types.md)
            * [Tuple Types](spec/tuple_types.md)
            * [Array Types](spec/array_types.md)
            * [Struct Types](spec/struct_types.md)
            * [Enumerated Types](spec/enumerated_types.md)
            * [Address Type](spec/address_type.md)
            * [HashMap Type](spec/hashmap_type.md)
            * [String Type](spec/string_type.md)
            * [Event Types](spec/event_types.md)
    * [Data Layout](spec/data_layout.md)
        * [Stack](spec/stack.md)
        * [Storage](spec/storage.md)
            * [Constant size values in storage](spec/constant_size_values_in_storage.md)
            * [Maps in storage](spec/maps_in_storage.md)
            * [`to_mem()` function](spec/to_mem_function.md)
        * [Memory](spec/memory.md)
            * [Sequence types in memory](spec/sequence_types_in_memory.md)
            * [`clone()` function](spec/clone_function.md)
    * [Function calls](spec/function_calls.md)

* [Release Notes](release_notes.md)
* [Code of Conduct](code_of_conduct.md)